



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>自定义jinja2 过滤器</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">自定义jinja2 过滤器</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-21 21:15:01 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>今天，我们要讲的是自定义jinja2 过滤器这个知识点，因为官方文档对此一代而过，讲得不够清楚，所以我们专门拿出来讲一下。</p>
<h1>例子</h1>
<p>例子写了两个自定义过滤器，一个是转换字典到字符串的过滤器，一个是返回当前参数的类型的过滤器。</p>
<p>源代码：</p>
<p><a href="https://github.com/lewis617/myflask/tree/master/jinja2-filter" rel="external nofollow noreferrer">https://github.com/lewis617/myflask/tree/master/jinja2-filter</a></p>
<h1>filter是个函数</h1>
<p>filter是个函数，跟angular的过滤器几乎一模一样。参数就是管道（pipe）前面那个变量。比如&nbsp;&nbsp; 123|myfilter，123就是myFilter的参数。如果需要两个参数，则在myFilter后面加（），即123|myFilter(234)。</p>
<h1>filter函数写在哪</h1>
<p>这是这个是编写filter的关键。filter函数写在app.run前，注册在app.jinja_env.filters中，这是什么意思？看代码：</p>
<div>
<pre class="prettyprint linenums">app = Flask(__name__)

# custom filter
# convert dict to string
def json_dumps(dict):
        result = json.dumps(dict)
        return result
# return type of arg
def typeFilter(arg):
        result = type(arg)
        return result

env = app.jinja_env
env.filters['json_dumps'] = json_dumps
env.filters['typeFilter'] = typeFilter</pre>
</div>
<ol><li>实例化一个Flask对象app</li>
<li>编写两个函数</li>
<li>将函数挂在app.jinja_env.filters上</li></ol>
<p>就是这么简单！</p>
<h1>测试示例代码</h1>
<p>第一个过滤器转换字典到字符串，第二个返回当前参数的类型</p>
<p>我们在index.html中编写：</p>
<div>
<pre class="prettyprint linenums">&lt;body&gt;
dict is {{ dict|typeFilter}}
&lt;hr&gt;
 dict | json_dumps is{{ dict|json_dumps |typeFilter}}
&lt;hr&gt;
you can use json_dumps filter to send dict to js,remember to add safe filter,&lt;br&gt;
press f12 to test it
&lt;/body&gt;
&lt;script&gt;
    //you can use json_dumps filter to send dict to js,remember to add safe filter
    console.log({{ dict |json_dumps|safe}})
&lt;/script&gt;</pre>
</div>
<p>然后在app.py中渲染这个html</p>
<div>
<pre class="prettyprint linenums">@app.route('/')
def hello_world():
    dict={'name':'lewis','age':24}
    return render_template('index.html',dict=dict)

if __name__ == '__main__':
    app.run()</pre>
</div>
<p>结果：</p>
<p><img referrerpolicy="no-referrer"src="http://images2015.cnblogs.com/blog/814069/201602/814069-20160207112723522-1653925353.png" /></p>
<p>json_dumps可以将dict转为字符串，这样我们用jinja渲染的对象列表之类的就可以，以字符串的形式打印出来，便于我们在开发环境下监视渲染状态。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49gmmx79.html">iOS之由身份证号返回性别</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8ml0409.html">vue路由的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvpd7xq.html">&amp;lt&semi;jsp&colon;include&amp;gt&semi;和&amp;lt&semi;&percnt;&commat;include file&equals;&amp;quot&semi;&amp;quot&semi;&percnt;&amp;gt&semi;区别【131031】</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd11o0q.html">静态成员函数（面向对象的static关键字）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xxem08.html">线性渐变--linear-gradient</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2w0wylq.html">清除SQL Server 2008中登陆时的历史记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1w66z9.html">开源的读取Excel文件组件-ExcelDataReader</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwdnrdl8.html">Android 全屏相关操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm7de69.html">&lbrack;MySQL&rsqb;快速解决&amp;quot&semi;is marked as crashed and should be repaired&amp;quot&semi;故障</a>
		</li>
						<li><a href="https://www.batexi.com/a/96o2z7j9.html">shit-------------mysql没有full join 语句</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjr4n49.html">AI大道理头尾标识</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rkwkj9.html">app测试自动化之定位元素</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjm2028.html">Concurrent包学习之 BlockingQueue源码学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwldjnr9.html">【BZOJ1077】天平（差分约束）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ppek08.html">Capability Model</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkv3118.html">开始使用ARC</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7e72jg9.html">Android 自动化测试 robotium</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o4rjepq.html">ubuntu16&period;04下安装pcl点云库</a>
		</li>
						<li><a href="https://www.batexi.com/a/9g31x74q.html">SaltStack配置salt-api第十二篇</a>
		</li>
						<li><a href="https://www.batexi.com/a/q15rkg49.html">ImportError&colon; No module named &amp;&num;39&semi;tkinter&amp;&num;39&semi;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/or93pg83.html">git-简单流程（学习笔记）</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2jlv87.html">ASP&period;NET MVC5&plus;EF6&plus;EasyUI 后台管理系统（80）-自由桌面</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gjj497.html">javascript中的继承与深度拷贝</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j1ew95.html">开始学nodejs&mdash;&mdash;net模块</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rnkrq0.html">Unity3D 5&period;3 新版AssetBundle使用方案及策略</a>
			</li>
						<li><a href="https://www.batexi.com/a/390j038d.html">Android 在Android代码中执行命令行</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlnrk8o.html">热修复-Tinker</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qn5nxqr.html">初识git版本控制系统</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mpxo8k.html">Redis配置文件redis&period;conf</a>
			</li>
						<li><a href="https://www.batexi.com/a/390pp48d.html">排序算法----调用库函数qsort进行快速排序</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
